/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tpBanqueGabertHasbi;

import java.util.Collection;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Philippe
 */
@Stateful
public class GestionnaireDeCompteBancaireBean implements GestionnaireDeCompteBancaireLocal {
    @PersistenceContext
    private EntityManager em;

    public void persist(Object object) {
        em.persist(object);
    }

    public void creer_compte(String nom, double solde)
    {
        CompteBancaire nouveau_compte = new CompteBancaire(nom, solde);
        persist(nouveau_compte);
    }

    public void afficher_liste_comptes()
    {
        Query query = em.createNamedQuery("CompteBancaire.findAll");
        Collection< CompteBancaire > result = query.getResultList();

        for(CompteBancaire cmpt:result ) {
            System.out.println("ID: " + cmpt.getId() + " - Propriétaire: "+cmpt.getNom() + " - Solde: " + cmpt.getSolde());
        }
    }
    public Collection liste_des_comptes()
    {
        Query query = em.createNamedQuery("CompteBancaire.findAll");
        Collection< CompteBancaire > result = query.getResultList();
        return result;
    }

    public int supprimerCompte(int id)
    {
        if(getCompteById(id) != null)
        {
            int query = em.createNamedQuery("CompteBancaire.supprByCompteId").setParameter("compteASupprimer", id).executeUpdate();
            return 1;
        }
        else
            return -1;
    }

    public int changerMontant(int id, double montant)
    {
        if(montant < 0)
        {
            return -2;
        }
        if(getCompteById(id) != null)
        {
            int query = em.createNamedQuery("CompteBancaire.MAJMontantById").setParameter("compteId", id).setParameter("montantSolde", montant).executeUpdate();
            return 0;
        }
        else
            return -1;
    }
    public void creerComptesTest()
    {
        creer_compte("John",150000000);
        creer_compte("Paul",150000000);
        creer_compte("Georges",150000000);
        creer_compte("Ringo",150000000);
    }

    public double getSoldeCompte(int idCompte)
    {
        return getCompteById(idCompte).getSolde();
    }
    
    public CompteBancaire getCompteById(int idCompte)
    {
        Query query = em.createNamedQuery("CompteBancaire.findByCompteId").setParameter("compteId", idCompte);
        CompteBancaire compte = (CompteBancaire)query.getSingleResult();
        return compte;
    }

    public int transfertCompte(int idSource, int idDest, double montant)
    {
        // 0 -->Le transfert est OK
        // -1 --> Il n'y a pas assez d'argent sur le compte émetteur
        // -2 --> Les utilisateurs sont identiques, le virement ne peut pas se faire.

        if(idSource == idDest)
            return -2;
        if(getSoldeCompte(idSource) >= montant)
        {
            getCompteById(idSource).retirer_argent(montant);
            getCompteById(idDest).ajouter_argent(montant);
            //persist(getCompteById(idSource));
            //persist(getCompteById(idDest));
            return 0;
        }
        else
            return -1;
    }
}
