/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tpBanqueGabertHasbi;

import java.io.IOException;

import java.util.Collection;
import java.util.Iterator;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Philippe
 */
public class ServletCompteAjax extends HttpServlet {

    @EJB
    private GestionnaireDeCompteBancaireLocal gestionnaireCompteBean;

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        if (request.getParameter("action") != null) {
            if (request.getParameter("action").equals("afficher")) {
                Collection compteBancaire1 = gestionnaireCompteBean.liste_des_comptes();
                request.setAttribute("CompteBancaire", compteBancaire1);
                RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                dp.forward(request, response);
            }
        } else {
            String reqAjax = request.getParameter("ReqAjax");
            if (reqAjax != null) {

                if (reqAjax.equals("compteParID")) {
                    String compteID = request.getParameter("compteID");

                    if (compteID != null) {
                        ajouterEntetes(response);
                        CompteBancaire compteBancaire = gestionnaireCompteBean.getCompteById(Integer.parseInt(compteID));
                        response.getWriter().write("<compte>" + compteBancaire.getNom() + "," + compteBancaire.getSolde() + "</compte>");
                        response.getWriter().write("</messageRetour>");
                    } else {
                        //nothing to show
                        response.setStatus(HttpServletResponse.SC_NO_CONTENT);
                    }
                }
                if (reqAjax.equals("creerNouveauCompte")) {
                    String nomProprietaire = request.getParameter("nouveauProp");
                    String solde = request.getParameter("nouveauSolde");
                    if (nomProprietaire != null && solde != null) {
                        gestionnaireCompteBean.creer_compte(nomProprietaire, Double.parseDouble(solde));
                        ajouterEntetes(response);
                        response.getWriter().write("Compte créé avec succès !");

                        Collection comptesBancaires = gestionnaireCompteBean.liste_des_comptes();
                        Iterator it = comptesBancaires.iterator();
                        while (it.hasNext()) {
                            CompteBancaire cmpt = (CompteBancaire) it.next();

                            response.getWriter().write("<compte>" + cmpt.getId() + "," + cmpt.getNom() + "," + cmpt.getSolde() + "</compte>");


                        }
                        response.getWriter().write("</messageRetour>");

                    } else {
                        ajouterEntetes(response);
                        response.getWriter().write("Création impossible, veuillez vérifier les paramètres entrés.</messageRetour>");
                    }
                }
                if (reqAjax.equals("transfert")) {
                    if (request.getParameter("compteSource") != null && request.getParameter("compteDestinataire") != null && request.getParameter("montantTransfert") != null) {
                        int idCompteSource = Integer.parseInt(request.getParameter("compteSource"));
                        int idCompteDesti = Integer.parseInt(request.getParameter("compteDestinataire"));
                        double montant = 0;
                        int ret = 0;
                        try {
                            montant = Double.parseDouble(request.getParameter("montantTransfert"));
                        } catch (Exception err) {
                            ret = -3;
                        }
                        if (montant < 0) {
                            ret = -3;
                        }
                        if (ret != -3) {
                            ret = gestionnaireCompteBean.transfertCompte(idCompteSource, idCompteDesti, montant);
                        }
                        ajouterEntetes(response);
                        switch (ret) {
                            case (0):
                                response.getWriter().write("Transfert terminé !");
                                break;
                            case (-1):
                                response.getWriter().write("Le compte émetteur n'a pas assez d'argent !");
                                break;
                            case (-2):
                                response.getWriter().write("Le compte émetteur doit être différent du compte destinataire.");
                                break;
                            case (-3):
                                response.getWriter().write("Le montant entré n'est pas correct !");
                                break;
                        }
                        Collection comptesBancaires = gestionnaireCompteBean.liste_des_comptes();
                        Iterator it = comptesBancaires.iterator();
                        while (it.hasNext()) {
                            CompteBancaire cmpt = (CompteBancaire) it.next();

                            response.getWriter().write("<compte>" + cmpt.getId() + "," + cmpt.getNom() + "," + cmpt.getSolde() + "</compte>");


                        }
                        response.getWriter().write("</messageRetour>");
                    } else {
                        ajouterEntetes(response);
                        response.getWriter().write("Les informations n'ont pas été envoyées correctement.</messageRetour>");
                    }
                }
                if (reqAjax.equals("listerComptes")) {


                    if (request.getParameter("compteNonListe") != null) {
                        //Lister tous les comptes
                        Collection comptesBancaires = gestionnaireCompteBean.liste_des_comptes();
                        Iterator it = comptesBancaires.iterator();
                        ajouterEntetes(response);
                        while (it.hasNext()) {
                            CompteBancaire cmpt = (CompteBancaire) it.next();
                            if (!request.getParameter("compteNonListe").equals(String.valueOf(cmpt.getId()))) {
                                response.getWriter().write("<compte>" + cmpt.getId() + "," + cmpt.getNom() + "," + cmpt.getSolde() + "</compte>");
                            }

                        }
                        response.getWriter().write("</messageRetour>");
                    } else {
                        // Lister tous les comptes.
                    }

                }
                if (reqAjax.equals("supprimerCompte")) {
                    if (request.getParameter("compteASuppr") != null) {

                        int ret = gestionnaireCompteBean.supprimerCompte(Integer.parseInt(request.getParameter("compteASuppr")));
                        if (ret == 1) {
                            Collection comptesBancaires = gestionnaireCompteBean.liste_des_comptes();
                            Iterator it = comptesBancaires.iterator();
                            ajouterEntetes(response);
                            response.getWriter().write("Compte supprimé");
                            while (it.hasNext()) {
                                CompteBancaire cmpt = (CompteBancaire) it.next();
                                response.getWriter().write("<compte>" + cmpt.getId() + "," + cmpt.getNom() + "," + cmpt.getSolde() + "</compte>");


                            }
                            response.getWriter().write("</messageRetour>");
                        } else if (ret == -1) {
                            ajouterEntetes(response);
                            response.getWriter().write("Le compte n'existe pas !</messageRetour>");
                        } else {
                            ajouterEntetes(response);
                            response.getWriter().write("Erreur lors de la suppression</messageRetour>");
                        }
                    }
                }
                if (reqAjax.equals("changerSolde")) {
                    if (request.getParameter("compteAModifier") != null && request.getParameter("montantChangerSolde") != null) {
                        int idCompte = Integer.parseInt(request.getParameter("compteAModifier"));
                        double montantNouv = Double.parseDouble(request.getParameter("montantChangerSolde"));
                        int ret = gestionnaireCompteBean.changerMontant(idCompte, montantNouv);
                        Collection comptesBancaires = gestionnaireCompteBean.liste_des_comptes();
                        Iterator it = comptesBancaires.iterator();
                        ajouterEntetes(response);
                        switch (ret) {
                            case (0):
                                response.getWriter().write("Montant modifié !");
                                break;
                            case (-1):
                                response.getWriter().write("Le compte à modifier n'a pas été spécifié.");
                                break;
                            case (-2):
                                response.getWriter().write("Le nouveau montant ne peut pas être inférieur à 0");
                                break;
                        }
                        while (it.hasNext()) {
                            CompteBancaire cmpt = (CompteBancaire) it.next();
                            response.getWriter().write("<compte>" + cmpt.getId() + "," + cmpt.getNom() + "," + cmpt.getSolde() + "</compte>");


                        }
                        response.getWriter().write("</messageRetour>");
                    }
                }

            }
        }
    }

    public void ajouterEntetes(HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/xml");
        response.setHeader("Cache-Control", "no-cache");
        response.getWriter().write("<messageRetour>");
    }
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">

    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
